# Connectors

Connectors are a way to push attributes of identities towards other systems.

Next to the existing connectors, you can craft your own connector.

For this to happen, create a new java maven project and include the following dependency.

```
<dependency>
    <groupId>be.personify.iam</groupId>
    <artifactId>personify-provisioning</artifactId>
    <version>LATEST VERSION</version>
</dependency>
```

Then you can extend the Connector class:

```java
...
import be.personify.iam.provisioning.connectors.Connector;
...

public CustomConnector extends Connector {


  /**
   * constructor to execute initialization actions
   */
  public CustomConnector(Map<String, String> config, List<TargetSystemAttribute> targetSystemAttributes) throws Exception {
	super(config, targetSystemAttributes);
	....
  }


}

```

Then you can implement all operations.

```java
abstract public Map<String,Object> resultToMap( Object o );

abstract public Map<String,Object> create(String id, Map<String,Object> objectRepresentation) throws Exception;
	
abstract public Map<String,Object> update(String id, Map<String,Object> objectRepresentation) throws Exception;

abstract public boolean delete(String id) throws Exception;
	
abstract public Map<String,Object> disable(String id) throws Exception;

abstract public Map<String,Object> find(String id) throws Exception;
	
abstract public List<Map<String, Object>> find(SearchCriteria searchCriteria, int start, int number, SortCriteria sortCriteria ) throws Exception;
	
abstract public List<String> findIds(SearchCriteria searcCriteria, int start, int number, SortCriteria sortCriteria) throws Exception;
	
abstract public Map<String,Object> archive(String id) throws Exception;

abstract public Map<String,Object> unarchive(String id) throws Exception;
	
abstract public boolean ping() throws Exception;

abstract public void checkConfiguration( Map<String, String> config ) throws Exception;
	
abstract public DeltaResult findDelta(String deltaIdentifier) throws Exception;
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.personify.be/development/customizations/connectors.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
